Index: uspace/app/ping6/ping6.c
===================================================================
--- uspace/app/ping6/ping6.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/app/ping6/ping6.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -42,6 +42,9 @@
 #include <inet/inetping6.h>
 #include <io/console.h>
+#include <getopt.h>
 #include <stdio.h>
 #include <stdlib.h>
+#include <str.h>
+#include <str_error.h>
 #include <sys/types.h>
 
@@ -54,9 +57,19 @@
 #define PING_TIMEOUT (1000 * 1000)
 
+typedef enum {
+	RECEIVED_NONE,
+	RECEIVED_SUCCESS,
+	RECEIVED_INTERRUPT
+} received_t;
+
+static received_t received;
+static FIBRIL_CONDVAR_INITIALIZE(received_cv);
+static FIBRIL_MUTEX_INITIALIZE(received_lock);
+
+static bool quit = false;
+static FIBRIL_CONDVAR_INITIALIZE(quit_cv);
+static FIBRIL_MUTEX_INITIALIZE(quit_lock);
+
 static int ping_ev_recv(inetping6_sdu_t *);
-
-static bool done = false;
-static FIBRIL_CONDVAR_INITIALIZE(done_cv);
-static FIBRIL_MUTEX_INITIALIZE(done_lock);
 
 static inetping6_ev_ops_t ev_ops = {
@@ -67,17 +80,28 @@
 static addr128_t dest;
 
-static bool ping_repeat = false;
+static bool repeat_forever = false;
+static size_t repeat_count = 1;
+
+static const char *short_options = "rn:";
 
 static void print_syntax(void)
 {
-	printf("syntax: " NAME " [-r] <host>\n");
-}
-
-static void ping_signal_done(void)
-{
-	fibril_mutex_lock(&done_lock);
-	done = true;
-	fibril_mutex_unlock(&done_lock);
-	fibril_condvar_broadcast(&done_cv);
+	printf("Syntax: %s [-n <count>|-r] <host>\n", NAME);
+}
+
+static void ping_signal_received(received_t value)
+{
+	fibril_mutex_lock(&received_lock);
+	received = value;
+	fibril_mutex_unlock(&received_lock);
+	fibril_condvar_broadcast(&received_cv);
+}
+
+static void ping_signal_quit(void)
+{
+	fibril_mutex_lock(&quit_lock);
+	quit = true;
+	fibril_mutex_unlock(&quit_lock);
+	fibril_condvar_broadcast(&quit_cv);
 }
 
@@ -102,9 +126,8 @@
 	}
 	
-	printf("Received ICMP echo reply: from %s to %s, seq. no %u, "
+	printf("Received ICMPv6 echo reply: from %s to %s, seq. no %u, "
 	    "payload size %zu\n", asrc, adest, sdu->seq_no, sdu->size);
 	
-	if (!ping_repeat)
-		ping_signal_done();
+	ping_signal_received(RECEIVED_SUCCESS);
 	
 	free(asrc);
@@ -116,6 +139,5 @@
 {
 	inetping6_sdu_t sdu;
-	int rc;
-
+	
 	addr128(src, sdu.src);
 	addr128(dest, sdu.dest);
@@ -123,12 +145,11 @@
 	sdu.data = (void *) "foo";
 	sdu.size = 3;
-
-	rc = inetping6_send(&sdu);
-	if (rc != EOK) {
-		printf(NAME ": Failed sending echo request (%d).\n", rc);
-		return rc;
-	}
-
-	return EOK;
+	
+	int rc = inetping6_send(&sdu);
+	if (rc != EOK)
+		printf("Failed sending echo request: %s (%d).\n",
+		    str_error(rc), rc);
+	
+	return rc;
 }
 
@@ -136,43 +157,60 @@
 {
 	uint16_t seq_no = 0;
-
+	
+	while ((repeat_count--) || (repeat_forever)) {
+		fibril_mutex_lock(&received_lock);
+		received = RECEIVED_NONE;
+		fibril_mutex_unlock(&received_lock);
+		
+		(void) ping_send(++seq_no);
+		
+		fibril_mutex_lock(&received_lock);
+		int rc = fibril_condvar_wait_timeout(&received_cv, &received_lock,
+		    PING_TIMEOUT);
+		received_t recv = received;
+		fibril_mutex_unlock(&received_lock);
+		
+		if ((rc == ETIMEOUT) || (recv == RECEIVED_NONE))
+			printf("Echo request timed out (seq. no %u)\n", seq_no);
+		
+		if (recv == RECEIVED_INTERRUPT)
+			break;
+		
+		if ((repeat_count > 0) || (repeat_forever)) {
+			fibril_mutex_lock(&received_lock);
+			rc = fibril_condvar_wait_timeout(&received_cv, &received_lock,
+			    PING_DELAY);
+			recv = received;
+			fibril_mutex_unlock(&received_lock);
+			
+			if (recv == RECEIVED_INTERRUPT)
+				break;
+		}
+	}
+	
+	ping_signal_quit();
+	return 0;
+}
+
+static int input_fibril(void *arg)
+{
+	console_ctrl_t *con = console_init(stdin, stdout);
+	
 	while (true) {
-		fibril_mutex_lock(&done_lock);
-		if (done) {
-			fibril_mutex_unlock(&done_lock);
-			return 0;
-		}
-		fibril_mutex_unlock(&done_lock);
-
-		(void) ping_send(++seq_no);
-		async_usleep(PING_DELAY);
-	}
-
-	return 0;
-}
-
-static int input_fibril(void *arg)
-{
-	console_ctrl_t *con;
-	cons_event_t ev;
-
-	con = console_init(stdin, stdout);
-	printf("[Press Ctrl-Q to quit]\n");
-
-	while (true) {
+		cons_event_t ev;
 		if (!console_get_event(con, &ev))
 			break;
-
-		if (ev.type == CEV_KEY && ev.ev.key.type == KEY_PRESS &&
-		    (ev.ev.key.mods & (KM_ALT | KM_SHIFT)) ==
-		    0 && (ev.ev.key.mods & KM_CTRL) != 0) {
+		
+		if ((ev.type == CEV_KEY) && (ev.ev.key.type == KEY_PRESS) &&
+		    ((ev.ev.key.mods & (KM_ALT | KM_SHIFT)) == 0) &&
+		    ((ev.ev.key.mods & KM_CTRL) != 0)) {
 			/* Ctrl+key */
 			if (ev.ev.key.key == KC_Q) {
-				ping_signal_done();
-				return 0;
+				ping_signal_received(RECEIVED_INTERRUPT);
+				break;
 			}
 		}
 	}
-
+	
 	return 0;
 }
@@ -184,35 +222,47 @@
 	char *adest = NULL;
 	char *sdest = NULL;
-	int rc;
-	int argi;
-
-	rc = inetping6_init(&ev_ops);
-	if (rc != EOK) {
-		printf(NAME ": Failed connecting to internet ping service "
-		    "(%d).\n", rc);
-		goto error;
-	}
-
-	argi = 1;
-	if (argi < argc && str_cmp(argv[argi], "-r") == 0) {
-		ping_repeat = true;
-		++argi;
-	} else {
-		ping_repeat = false;
-	}
-
-	if (argc - argi != 1) {
+	
+	int rc = inetping6_init(&ev_ops);
+	if (rc != EOK) {
+		printf("Failed connecting to internet ping service: "
+		    "%s (%d).\n", str_error(rc), rc);
+		goto error;
+	}
+	
+	int c;
+	while ((c = getopt(argc, argv, short_options)) != -1) {
+		switch (c) {
+		case 'r':
+			repeat_forever = true;
+			break;
+		case 'n':
+			rc = str_size_t(optarg, NULL, 10, true, &repeat_count);
+			if (rc != EOK) {
+				printf("Invalid repeat count.\n");
+				print_syntax();
+				goto error;
+			}
+			break;
+		default:
+			printf("Unknown option passed.\n");
+			print_syntax();
+			goto error;
+		}
+	}
+	
+	if (optind >= argc) {
+		printf("IP address or host name not supplied.\n");
 		print_syntax();
 		goto error;
 	}
-
+	
 	/* Parse destination address */
 	inet_addr_t dest_addr;
-	rc = inet_addr_parse(argv[argi], &dest_addr);
+	rc = inet_addr_parse(argv[optind], &dest_addr);
 	if (rc != EOK) {
 		/* Try interpreting as a host name */
-		rc = dnsr_name2host(argv[argi], &hinfo);
+		rc = dnsr_name2host(argv[optind], &hinfo, AF_INET);
 		if (rc != EOK) {
-			printf(NAME ": Error resolving host '%s'.\n", argv[argi]);
+			printf("Error resolving host '%s'.\n", argv[optind]);
 			goto error;
 		}
@@ -223,6 +273,6 @@
 	uint16_t af = inet_addr_get(&dest_addr, NULL, &dest);
 	if (af != AF_INET6) {
-		printf(NAME ": Destination '%s' is not an IPv6 address.\n",
-		    argv[argi]);
+		printf("Destination '%s' is not an IPv6 address.\n",
+		    argv[optind]);
 		goto error;
 	}
@@ -231,5 +281,5 @@
 	rc = inetping6_get_srcaddr(dest, src);
 	if (rc != EOK) {
-		printf(NAME ": Failed determining source address.\n");
+		printf("Failed determining source address.\n");
 		goto error;
 	}
@@ -240,5 +290,5 @@
 	rc = inet_addr_format(&src_addr, &asrc);
 	if (rc != EOK) {
-		printf(NAME ": Out of memory.\n");
+		printf("Out of memory.\n");
 		goto error;
 	}
@@ -246,5 +296,5 @@
 	rc = inet_addr_format(&dest_addr, &adest);
 	if (rc != EOK) {
-		printf(NAME ": Out of memory.\n");
+		printf("Out of memory.\n");
 		goto error;
 	}
@@ -253,5 +303,5 @@
 		rc = asprintf(&sdest, "%s (%s)", hinfo->cname, adest);
 		if (rc < 0) {
-			printf(NAME ": Out of memory.\n");
+			printf("Out of memory.\n");
 			goto error;
 		}
@@ -260,43 +310,29 @@
 		adest = NULL;
 	}
-
-	printf("Sending ICMP echo request from %s to %s.\n",
+	
+	printf("Sending ICMP echo request from %s to %s (Ctrl+Q to quit)\n",
 	    asrc, sdest);
-
-	fid_t fid;
-
-	if (ping_repeat) {
-		fid = fibril_create(transmit_fibril, NULL);
-		if (fid == 0) {
-			printf(NAME ": Failed creating transmit fibril.\n");
-			goto error;
-		}
-
-		fibril_add_ready(fid);
-
-		fid = fibril_create(input_fibril, NULL);
-		if (fid == 0) {
-			printf(NAME ": Failed creating input fibril.\n");
-			goto error;
-		}
-
-		fibril_add_ready(fid);
-	} else {
-		ping_send(1);
-	}
-
-	fibril_mutex_lock(&done_lock);
-	rc = EOK;
-	while (!done && rc != ETIMEOUT) {
-		rc = fibril_condvar_wait_timeout(&done_cv, &done_lock,
-			ping_repeat ? 0 : PING_TIMEOUT);
-	}
-	fibril_mutex_unlock(&done_lock);
-
-	if (rc == ETIMEOUT) {
-		printf(NAME ": Echo request timed out.\n");
-		goto error;
-	}
-
+	
+	fid_t fid = fibril_create(transmit_fibril, NULL);
+	if (fid == 0) {
+		printf("Failed creating transmit fibril.\n");
+		goto error;
+	}
+	
+	fibril_add_ready(fid);
+	
+	fid = fibril_create(input_fibril, NULL);
+	if (fid == 0) {
+		printf("Failed creating input fibril.\n");
+		goto error;
+	}
+	
+	fibril_add_ready(fid);
+	
+	fibril_mutex_lock(&quit_lock);
+	while (!quit)
+		fibril_condvar_wait(&quit_cv, &quit_lock);
+	fibril_mutex_unlock(&quit_lock);
+	
 	free(asrc);
 	free(adest);
Index: uspace/lib/c/generic/dnsr.c
===================================================================
--- uspace/lib/c/generic/dnsr.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/lib/c/generic/dnsr.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -67,5 +67,5 @@
 }
 
-int dnsr_name2host(const char *name, dnsr_hostinfo_t **rinfo)
+int dnsr_name2host(const char *name, dnsr_hostinfo_t **rinfo, uint16_t af)
 {
 	dnsr_hostinfo_t *info = calloc(1, sizeof(dnsr_hostinfo_t));
@@ -76,5 +76,6 @@
 	
 	ipc_call_t answer;
-	aid_t req = async_send_0(exch, DNSR_NAME2HOST, &answer);
+	aid_t req = async_send_1(exch, DNSR_NAME2HOST, (sysarg_t) af,
+	    &answer);
 	
 	int rc = async_data_write_start(exch, name, str_size(name));
Index: uspace/lib/c/generic/inet/addr.c
===================================================================
--- uspace/lib/c/generic/inet/addr.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/lib/c/generic/inet/addr.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -52,4 +52,8 @@
 };
 
+static const addr48_t inet_addr48_solicited_node = {
+	0x33, 0x33, 0xff, 0, 0, 0
+};
+
 static const inet_addr_t inet_addr_any_addr = {
 	.family = AF_INET,
@@ -72,7 +76,24 @@
 }
 
+int addr48_compare(const addr48_t a, const addr48_t b)
+{
+	return memcmp(a, b, 6);
+}
+
 int addr128_compare(const addr128_t a, const addr128_t b)
 {
 	return memcmp(a, b, 16);
+}
+
+/** Compute solicited node MAC multicast address from target IPv6 address
+ *
+ * @param ip  Target IPv6 address
+ * @param mac Solicited MAC address to be assigned
+ *
+ */
+void addr48_solicited_node(const addr128_t ip, addr48_t mac)
+{
+	memcpy(mac, inet_addr48_solicited_node, 3);
+	memcpy(mac + 3, ip + 13, 3);
 }
 
@@ -260,4 +281,19 @@
 }
 
+int inet_naddr_compare(const inet_naddr_t *naddr, const inet_addr_t *addr)
+{
+	if (naddr->family != addr->family)
+		return 0;
+	
+	switch (naddr->family) {
+	case AF_INET:
+		return (naddr->addr == addr->addr);
+	case AF_INET6:
+		return addr128_compare(naddr->addr6, addr->addr6);
+	default:
+		return 0;
+	}
+}
+
 int inet_naddr_compare_mask(const inet_naddr_t *naddr, const inet_addr_t *addr)
 {
Index: uspace/lib/c/include/inet/addr.h
===================================================================
--- uspace/lib/c/include/inet/addr.h	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/lib/c/include/inet/addr.h	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -73,5 +73,8 @@
 extern void addr128(const addr128_t, addr128_t);
 
+extern int addr48_compare(const addr48_t, const addr48_t);
 extern int addr128_compare(const addr128_t, const addr128_t);
+
+extern void addr48_solicited_node(const addr128_t, addr48_t);
 
 extern void host2addr128_t_be(const addr128_t, addr128_t);
@@ -97,4 +100,5 @@
 extern int inet_addr_is_any(const inet_addr_t *);
 
+extern int inet_naddr_compare(const inet_naddr_t *, const inet_addr_t *);
 extern int inet_naddr_compare_mask(const inet_naddr_t *, const inet_addr_t *);
 
Index: uspace/lib/c/include/inet/dnsr.h
===================================================================
--- uspace/lib/c/include/inet/dnsr.h	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/lib/c/include/inet/dnsr.h	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -51,5 +51,5 @@
 
 extern int dnsr_init(void);
-extern int dnsr_name2host(const char *, dnsr_hostinfo_t **);
+extern int dnsr_name2host(const char *, dnsr_hostinfo_t **, uint16_t);
 extern void dnsr_hostinfo_destroy(dnsr_hostinfo_t *);
 extern int dnsr_get_srvaddr(inet_addr_t *);
Index: uspace/lib/posix/include/posix/stdio.h
===================================================================
--- uspace/lib/posix/include/posix/stdio.h	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/lib/posix/include/posix/stdio.h	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -65,7 +65,4 @@
 
 #define BUFSIZ  4096
-#define SEEK_SET  0
-#define SEEK_CUR  1
-#define SEEK_END  2
 
 typedef struct _IO_FILE FILE;
Index: uspace/lib/posix/include/posix/stdlib.h
===================================================================
--- uspace/lib/posix/include/posix/stdlib.h	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/lib/posix/include/posix/stdlib.h	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -46,4 +46,6 @@
 	#define NULL  ((void *) 0)
 #endif
+
+#define RAND_MAX  714025
 
 /* Process Termination */
@@ -122,4 +124,8 @@
 extern int __POSIX_DEF__(mkstemp)(char *tmpl);
 
+/* Pseudo-random number generator */
+extern int __POSIX_DEF__(rand)(void);
+extern void __POSIX_DEF__(srand)(unsigned int seed);
+
 /* Legacy Declarations */
 extern char *__POSIX_DEF__(mktemp)(char *tmpl);
Index: uspace/lib/posix/include/posix/time.h
===================================================================
--- uspace/lib/posix/include/posix/time.h	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/lib/posix/include/posix/time.h	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -87,4 +87,7 @@
 extern void __POSIX_DEF__(tzset)(void);
 
+/* Time */
+extern time_t __POSIX_DEF__(time)(time_t *t);
+
 /* Broken-down Time */
 extern struct tm *__POSIX_DEF__(gmtime_r)(const time_t *restrict timer,
Index: uspace/lib/posix/include/posix/unistd.h
===================================================================
--- uspace/lib/posix/include/posix/unistd.h	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/lib/posix/include/posix/unistd.h	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -44,4 +44,8 @@
 #include "stddef.h"
 
+#define SEEK_SET  0
+#define SEEK_CUR  1
+#define SEEK_END  2
+
 /* Process Termination */
 #define _exit exit
@@ -77,4 +81,6 @@
 extern ssize_t __POSIX_DEF__(read)(int fildes, void *buf, size_t nbyte);
 extern ssize_t __POSIX_DEF__(write)(int fildes, const void *buf, size_t nbyte);
+extern __POSIX_DEF__(off_t) __POSIX_DEF__(lseek)(int fildes,
+    __POSIX_DEF__(off_t) offset, int whence);
 extern int __POSIX_DEF__(fsync)(int fildes);
 extern int __POSIX_DEF__(ftruncate)(int fildes, __POSIX_DEF__(off_t) length);
Index: uspace/lib/posix/source/stdlib.c
===================================================================
--- uspace/lib/posix/source/stdlib.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/lib/posix/source/stdlib.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -394,4 +394,24 @@
 
 /**
+ * Generate a pseudo random integer in the range 0 to RAND_MAX inclusive.
+ *
+ * @return The pseudo random integer.
+ */
+int posix_rand(void)
+{
+	return (int) random();
+}
+
+/**
+ * Initialize a new sequence of pseudo-random integers.
+ *
+ * @param seed The seed of the new sequence.
+ */
+void posix_srand(unsigned int seed)
+{
+	srandom(seed);
+}
+
+/**
  * Creates and opens an unique temporary file from template.
  *
Index: uspace/lib/posix/source/time.c
===================================================================
--- uspace/lib/posix/source/time.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/lib/posix/source/time.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -74,4 +74,17 @@
 	posix_daylight = 0;
 	posix_timezone = 0;
+}
+
+/**
+ * Get the time in seconds
+ *
+ * @param t If t is non-NULL, the return value is also stored in the memory
+ *          pointed to by t.
+ * @return  On success, the value of time in seconds since the Epoch
+ *          is returned. On error, (time_t)-1 is returned.
+ */
+time_t posix_time(time_t *t)
+{
+	return time(t);
 }
 
Index: uspace/lib/posix/source/unistd.c
===================================================================
--- uspace/lib/posix/source/unistd.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/lib/posix/source/unistd.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -221,4 +221,18 @@
 {
 	return errnify(write, fildes, buf, nbyte);
+}
+
+/**
+ * Reposition read/write file offset
+ *
+ * @param fildes File descriptor of the opened file.
+ * @param offset New offset in the file.
+ * @param whence The position from which the offset argument is specified.
+ * @return Upon successful completion, returns the resulting offset
+ *         as measured in bytes from the beginning of the file, -1 otherwise.
+ */
+posix_off_t posix_lseek(int fildes, posix_off_t offset, int whence)
+{
+	return errnify(lseek, fildes, offset, whence);
 }
 
Index: uspace/srv/net/dnsrsrv/dns_msg.c
===================================================================
--- uspace/srv/net/dnsrsrv/dns_msg.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/dnsrsrv/dns_msg.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -296,13 +296,20 @@
 uint32_t dns_uint32_t_decode(uint8_t *buf, size_t buf_size)
 {
-	uint32_t w;
 	assert(buf_size >= 4);
-
-	w = ((uint32_t) buf[0] << 24) +
+	
+	uint32_t w = ((uint32_t) buf[0] << 24) +
 	    ((uint32_t) buf[1] << 16) +
 	    ((uint32_t) buf[2] << 8) +
 	    buf[3];
-
+	
 	return w;
+}
+
+/** Decode unaligned big-endian 128-bit integer */
+void dns_addr128_t_decode(uint8_t *buf, size_t buf_size, addr128_t addr)
+{
+	assert(buf_size >= 16);
+	
+	addr128_t_be2host(buf, addr);
 }
 
@@ -400,5 +407,5 @@
 	int rc;
 
-	rr = calloc(1, sizeof (dns_rr_t));
+	rr = calloc(1, sizeof(dns_rr_t));
 	if (rr == NULL)
 		return ENOMEM;
@@ -427,14 +434,18 @@
 
 	rr->rtype = dns_uint16_t_decode(bp, bsz);
-	bp += sizeof(uint16_t); bsz -= sizeof(uint16_t);
+	bp += sizeof(uint16_t);
+	bsz -= sizeof(uint16_t);
 
 	rr->rclass = dns_uint16_t_decode(bp, bsz);
-	bp += sizeof(uint16_t); bsz -= sizeof(uint16_t);
+	bp += sizeof(uint16_t);
+	bsz -= sizeof(uint16_t);
 
 	rr->ttl = dns_uint32_t_decode(bp, bsz);
-	bp += sizeof(uint32_t); bsz -= sizeof(uint32_t);
+	bp += sizeof(uint32_t);
+	bsz -= sizeof(uint32_t);
 
 	rdlength = dns_uint16_t_decode(bp, bsz);
-	bp += sizeof(uint16_t); bsz -= sizeof(uint16_t);
+	bp += sizeof(uint16_t);
+	bsz -= sizeof(uint16_t);
 
 	if (rdlength > bsz) {
Index: uspace/srv/net/dnsrsrv/dns_msg.h
===================================================================
--- uspace/srv/net/dnsrsrv/dns_msg.h	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/dnsrsrv/dns_msg.h	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -40,4 +40,5 @@
 #include <stdbool.h>
 #include <stdint.h>
+#include <inet/addr.h>
 #include "dns_std.h"
 #include "dns_type.h"
@@ -49,4 +50,5 @@
 extern int dns_name_decode(dns_pdu_t *, size_t, char **, size_t *);
 extern uint32_t dns_uint32_t_decode(uint8_t *, size_t);
+extern void dns_addr128_t_decode(uint8_t *, size_t, addr128_t);
 
 #endif
Index: uspace/srv/net/dnsrsrv/dns_std.h
===================================================================
--- uspace/srv/net/dnsrsrv/dns_std.h	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/dnsrsrv/dns_std.h	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -65,4 +65,5 @@
 	DTYPE_MX	= 15,
 	DTYPE_TXT	= 16,
+	DTYPE_AAAA	= 28,
 	DQTYPE_AXFR	= 252,
 	DQTYPE_MAILB	= 253,
Index: uspace/srv/net/dnsrsrv/dnsrsrv.c
===================================================================
--- uspace/srv/net/dnsrsrv/dnsrsrv.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/dnsrsrv/dnsrsrv.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -89,4 +89,6 @@
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "inet_get_srvaddr_srv()");
 	
+	uint16_t af = IPC_GET_ARG1(*icall);
+	
 	char *name;
 	int rc = async_data_write_accept((void **) &name, true, 0,
@@ -98,5 +100,5 @@
 	
 	dns_host_info_t *hinfo;
-	rc = dns_name2host(name, &hinfo);
+	rc = dns_name2host(name, &hinfo, af);
 	if (rc != EOK) {
 		async_answer_0(iid, rc);
Index: uspace/srv/net/dnsrsrv/query.c
===================================================================
--- uspace/srv/net/dnsrsrv/query.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/dnsrsrv/query.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -39,5 +39,5 @@
 #include <stdlib.h>
 #include <str.h>
-
+#include <net/socket_codes.h>
 #include "dns_msg.h"
 #include "dns_std.h"
@@ -48,28 +48,37 @@
 static uint16_t msg_id;
 
-int dns_name2host(const char *name, dns_host_info_t **rinfo)
+static int dns_name_query(const char *name, dns_qtype_t qtype,
+    dns_host_info_t *info)
 {
-	dns_message_t *msg;
-	dns_message_t *amsg;
-	dns_question_t *question;
-	dns_host_info_t *info;
-	char *sname, *cname;
-	size_t eoff;
-	int rc;
-
-	question = calloc(1, sizeof(dns_question_t));
-	if (question == NULL)
-		return ENOMEM;
-
-	question->qname = (char *)name;
-	question->qtype = DTYPE_A;
+	/* Start with the caller-provided name */
+	char *sname = str_dup(name);
+	if (sname == NULL)
+		return ENOMEM;
+	
+	char *qname = str_dup(name);
+	if (qname == NULL) {
+		free(sname);
+		return ENOMEM;
+	}
+	
+	dns_question_t *question = calloc(1, sizeof(dns_question_t));
+	if (question == NULL) {
+		free(qname);
+		free(sname);
+		return ENOMEM;
+	}
+	
+	question->qname = qname;
+	question->qtype = qtype;
 	question->qclass = DC_IN;
-
-	msg = dns_message_new();
-	if (msg == NULL)
-		return ENOMEM;
-
-	list_append(&question->msg, &msg->question);
-
+	
+	dns_message_t *msg = dns_message_new();
+	if (msg == NULL) {
+		free(question);
+		free(qname);
+		free(sname);
+		return ENOMEM;
+	}
+	
 	msg->id = msg_id++;
 	msg->qr = QR_QUERY;
@@ -79,53 +88,63 @@
 	msg->rd = true;
 	msg->ra = false;
-
-	rc = dns_request(msg, &amsg);
+	
+	list_append(&question->msg, &msg->question);
+	
+	dns_message_t *amsg;
+	int rc = dns_request(msg, &amsg);
 	if (rc != EOK) {
+		dns_message_destroy(msg);
+		free(sname);
 		return rc;
 	}
-
-	/* Start with the caller-provided name */
-	sname = str_dup(name);
-
+	
 	list_foreach(amsg->answer, link) {
 		dns_rr_t *rr = list_get_instance(link, dns_rr_t, msg);
-
+		
 		log_msg(LOG_DEFAULT, LVL_DEBUG, " - '%s' %u/%u, dsize %zu",
-			rr->name, rr->rtype, rr->rclass, rr->rdata_size);
-
-		if (rr->rtype == DTYPE_CNAME && rr->rclass == DC_IN &&
-		    str_cmp(rr->name, sname) == 0) {
+		    rr->name, rr->rtype, rr->rclass, rr->rdata_size);
+		
+		if ((rr->rtype == DTYPE_CNAME) && (rr->rclass == DC_IN) &&
+		    (str_cmp(rr->name, sname) == 0)) {
+			
 			log_msg(LOG_DEFAULT, LVL_DEBUG, "decode cname (%p, %zu, %zu)",
 			    amsg->pdu.data, amsg->pdu.size, rr->roff);
+			
+			char *cname;
+			size_t eoff;
 			rc = dns_name_decode(&amsg->pdu, rr->roff, &cname, &eoff);
 			if (rc != EOK) {
-				log_msg(LOG_DEFAULT, LVL_DEBUG,
-				    "error decoding cname");
-				assert(rc == EINVAL || rc == ENOMEM);
+				assert((rc == EINVAL) || (rc == ENOMEM));
+				
+				log_msg(LOG_DEFAULT, LVL_DEBUG, "error decoding cname");
+				
 				dns_message_destroy(msg);
 				dns_message_destroy(amsg);
+				free(sname);
+				
 				return rc;
 			}
-
+			
 			log_msg(LOG_DEFAULT, LVL_DEBUG, "name = '%s' "
 			    "cname = '%s'", sname, cname);
-
+			
+			/* Continue looking for the more canonical name */
 			free(sname);
-			/* Continue looking for the more canonical name */
 			sname = cname;
 		}
-
-		if (rr->rtype == DTYPE_A && rr->rclass == DC_IN &&
-			rr->rdata_size == sizeof(uint32_t) &&
-			    str_cmp(rr->name, sname) == 0) {
-
-			info = calloc(1, sizeof(dns_host_info_t));
-			if (info == NULL) {
+		
+		if ((qtype == DTYPE_A) && (rr->rtype == DTYPE_A) &&
+		    (rr->rclass == DC_IN) && (rr->rdata_size == sizeof(addr32_t)) &&
+		    (str_cmp(rr->name, sname) == 0)) {
+			
+			info->cname = str_dup(rr->name);
+			if (info->cname == NULL) {
 				dns_message_destroy(msg);
 				dns_message_destroy(amsg);
+				free(sname);
+				
 				return ENOMEM;
 			}
-
-			info->cname = str_dup(rr->name);
+			
 			inet_addr_set(dns_uint32_t_decode(rr->rdata, rr->rdata_size),
 			    &info->addr);
@@ -133,14 +152,76 @@
 			dns_message_destroy(msg);
 			dns_message_destroy(amsg);
-			*rinfo = info;
+			free(sname);
+			
 			return EOK;
 		}
-	}
-
+		
+		if ((qtype == DTYPE_AAAA) && (rr->rtype == DTYPE_AAAA) &&
+		    (rr->rclass == DC_IN) && (rr->rdata_size == sizeof(addr128_t)) &&
+		    (str_cmp(rr->name, sname) == 0)) {
+		
+			info->cname = str_dup(rr->name);
+			if (info->cname == NULL) {
+				dns_message_destroy(msg);
+				dns_message_destroy(amsg);
+				free(sname);
+				
+				return ENOMEM;
+			}
+			
+			addr128_t addr;
+			dns_addr128_t_decode(rr->rdata, rr->rdata_size, addr);
+			
+			inet_addr_set6(addr, &info->addr);
+			
+			dns_message_destroy(msg);
+			dns_message_destroy(amsg);
+			free(sname);
+			
+			return EOK;
+		}
+	}
+	
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "'%s' not resolved, fail", sname);
+	
 	dns_message_destroy(msg);
 	dns_message_destroy(amsg);
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "'%s' not resolved, fail", sname);
-
+	free(sname);
+	
 	return EIO;
+}
+
+int dns_name2host(const char *name, dns_host_info_t **rinfo, uint16_t af)
+{
+	dns_host_info_t *info = calloc(1, sizeof(dns_host_info_t));
+	if (info == NULL)
+		return ENOMEM;
+	
+	int rc;
+	
+	switch (af) {
+	case AF_NONE:
+		rc = dns_name_query(name, DTYPE_AAAA, info);
+		
+		if (rc != EOK)
+			rc = dns_name_query(name, DTYPE_A, info);
+		
+		break;
+	case AF_INET:
+		rc = dns_name_query(name, DTYPE_A, info);
+		break;
+	case AF_INET6:
+		rc = dns_name_query(name, DTYPE_AAAA, info);
+		break;
+	default:
+		rc = EINVAL;
+	}
+	
+	if (rc == EOK)
+		*rinfo = info;
+	else
+		free(info);
+	
+	return rc;
 }
 
Index: uspace/srv/net/dnsrsrv/query.h
===================================================================
--- uspace/srv/net/dnsrsrv/query.h	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/dnsrsrv/query.h	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -39,5 +39,5 @@
 #include "dns_type.h"
 
-extern int dns_name2host(const char *, dns_host_info_t **);
+extern int dns_name2host(const char *, dns_host_info_t **, uint16_t);
 extern void dns_hostinfo_destroy(dns_host_info_t *);
 
Index: uspace/srv/net/ethip/ethip.h
===================================================================
--- uspace/srv/net/ethip/ethip.h	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/ethip/ethip.h	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -46,10 +46,10 @@
 
 typedef struct {
-	link_t addr_list;
+	link_t link;
 	inet_addr_t addr;
 } ethip_link_addr_t;
 
 typedef struct ethip_nic {
-	link_t nic_list;
+	link_t link;
 	service_id_t svc_id;
 	char *svc_name;
@@ -61,6 +61,10 @@
 	/** MAC address */
 	addr48_t mac_addr;
-	/** List of IP addresses configured on this link */
-	list_t addr_list; /* of ethip_link_addr_t */
+	
+	/**
+	 * List of IP addresses configured on this link
+	 * (of the type ethip_link_addr_t)
+	 */
+	list_t addr_list;
 } ethip_nic_t;
 
Index: uspace/srv/net/ethip/ethip_nic.c
===================================================================
--- uspace/srv/net/ethip/ethip_nic.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/ethip/ethip_nic.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -45,5 +45,6 @@
 #include <device/nic.h>
 #include <stdlib.h>
-
+#include <net/socket_codes.h>
+#include <mem.h>
 #include "ethip.h"
 #include "ethip_nic.h"
@@ -83,7 +84,7 @@
 		already_known = false;
 
-		list_foreach(ethip_nic_list, nic_link) {
-			ethip_nic_t *nic = list_get_instance(nic_link,
-			    ethip_nic_t, nic_list);
+		list_foreach(ethip_nic_list, link) {
+			ethip_nic_t *nic = list_get_instance(link,
+			    ethip_nic_t, link);
 			if (nic->svc_id == svcs[i]) {
 				already_known = true;
@@ -108,5 +109,4 @@
 {
 	ethip_nic_t *nic = calloc(1, sizeof(ethip_nic_t));
-
 	if (nic == NULL) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed allocating NIC structure. "
@@ -114,8 +114,8 @@
 		return NULL;
 	}
-
-	link_initialize(&nic->nic_list);
+	
+	link_initialize(&nic->link);
 	list_initialize(&nic->addr_list);
-
+	
 	return nic;
 }
@@ -130,5 +130,5 @@
 	}
 	
-	link_initialize(&laddr->addr_list);
+	link_initialize(&laddr->link);
 	laddr->addr = *addr;
 	
@@ -140,4 +140,5 @@
 	if (nic->svc_name != NULL)
 		free(nic->svc_name);
+	
 	free(nic);
 }
@@ -180,5 +181,5 @@
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "Opened NIC '%s'", nic->svc_name);
-	list_append(&nic->nic_list, &ethip_nic_list);
+	list_append(&nic->link, &ethip_nic_list);
 	in_list = true;
 
@@ -209,7 +210,9 @@
 error:
 	if (in_list)
-		list_remove(&nic->nic_list);
+		list_remove(&nic->link);
+	
 	if (nic->sess != NULL)
 		async_hangup(nic->sess);
+	
 	ethip_nic_delete(nic);
 	return rc;
@@ -312,6 +315,5 @@
 	list_foreach(ethip_nic_list, link) {
 		log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_nic_find_by_iplink_sid - element");
-		ethip_nic_t *nic = list_get_instance(link, ethip_nic_t,
-		    nic_list);
+		ethip_nic_t *nic = list_get_instance(link, ethip_nic_t, link);
 
 		if (nic->iplink_sid == iplink_sid) {
@@ -334,4 +336,80 @@
 }
 
+/** Setup accepted multicast addresses
+ *
+ * Currently the set of accepted multicast addresses is
+ * determined only based on IPv6 addresses.
+ *
+ */
+static int ethip_nic_setup_multicast(ethip_nic_t *nic)
+{
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_nic_setup_multicast()");
+	
+	/* Count the number of multicast addresses */
+	
+	size_t count = 0;
+	
+	list_foreach(nic->addr_list, link) {
+		ethip_link_addr_t *laddr = list_get_instance(link,
+		    ethip_link_addr_t, link);
+		
+		uint16_t af = inet_addr_get(&laddr->addr, NULL, NULL);
+		if (af == AF_INET6)
+			count++;
+	}
+	
+	if (count == 0)
+		return nic_multicast_set_mode(nic->sess, NIC_MULTICAST_BLOCKED,
+		    NULL, 0);
+	
+	nic_address_t *mac_list = calloc(count, sizeof(nic_address_t));
+	if (mac_list == NULL)
+		return ENOMEM;
+	
+	/* Create the multicast MAC list */
+	
+	size_t i = 0;
+	
+	list_foreach(nic->addr_list, link) {
+		assert(i < count);
+		
+		ethip_link_addr_t *laddr = list_get_instance(link,
+		    ethip_link_addr_t, link);
+		
+		addr128_t v6;
+		uint16_t af = inet_addr_get(&laddr->addr, NULL, &v6);
+		if (af != AF_INET6)
+			continue;
+		
+		addr48_t mac;
+		addr48_solicited_node(v6, mac);
+		
+		/* Avoid duplicate addresses in the list */
+		
+		bool found = false;
+		
+		for (size_t j = 0; j < i; j++) {
+			if (addr48_compare(mac_list[j].address, mac)) {
+				found = true;
+				break;
+			}
+		}
+		
+		if (!found) {
+			addr48(mac, mac_list[i].address);
+			i++;
+		} else
+			count--;
+	}
+	
+	/* Setup the multicast MAC list */
+	
+	int rc = nic_multicast_set_mode(nic->sess, NIC_MULTICAST_LIST,
+	    mac_list, count);
+	
+	free(mac_list);
+	return rc;
+}
+
 int ethip_nic_addr_add(ethip_nic_t *nic, inet_addr_t *addr)
 {
@@ -342,6 +420,7 @@
 		return ENOMEM;
 	
-	list_append(&laddr->addr_list, &nic->addr_list);
-	return EOK;
+	list_append(&laddr->link, &nic->addr_list);
+	
+	return ethip_nic_setup_multicast(nic);
 }
 
@@ -354,7 +433,8 @@
 		return ENOENT;
 	
-	list_remove(&laddr->addr_list);
+	list_remove(&laddr->link);
 	ethip_link_addr_delete(laddr);
-	return EOK;
+	
+	return ethip_nic_setup_multicast(nic);
 }
 
@@ -366,5 +446,5 @@
 	list_foreach(nic->addr_list, link) {
 		ethip_link_addr_t *laddr = list_get_instance(link,
-		    ethip_link_addr_t, addr_list);
+		    ethip_link_addr_t, link);
 		
 		if (inet_addr_compare(addr, &laddr->addr))
